#if	defined(WIN32)
#	define	FI64	"I64"
#	define	I64(n)	n##i64
#endif
#if	defined(LINUX)
#	define	FI64	"ll"
#	define	I64(n)	n##ll
# define	_istdigit	isdigit
# define	_putts		puts
# define	_stprintf	sprintf
# define	_tcslen		strlen
# define	_tcscpy		strcpy
# define	_tcsicmp	strcasecmp
# define	_tcsncmp	strncmp
# define	_tcsnicmp	strncasecmp
# define	_tcsncpy	strncpy
# define	_totupper	toupper
#endif

#if	defined(WIN32)
#	define	MSLEEP(msec)	::Sleep(msec)
#endif
#if	defined(LINUX)
#	define	MSLEEP(msec)	usleep((__useconds_t)msec*1000ll)
#endif

//	DEBUG, _DEBUG
#if	defined(_DEBUG)
# if	! defined(DEBUG)
#   define	DEBUG
# endif
#endif
#if	defined(DEBUG)
# if	! defined(_DEBUG)
#   define	_DEBUG
# endif
#endif
