//////////////////////////////////////////////////////////////////////////
//	"devctl_smart.cpp"
//------------------------------------------------------------------------
//	$Id: devctl_smart.cpp 163 2006-02-25 12:25:23Z taro $
//////////////////////////////////////////////////////////////////////////

#include	"devctl.h"
#include	"linux/hdreg.h"

#define	HDIO_DRIVE_CMD_OFFSET	4
#define STRANGE_BUFFER_LENGTH	(4+512*0xF8)

#if 0
int		DevCtl::SmartIoControl(DevCtl::SmartIoCtl ioctl, unsigned inp_size, BYTE * inp_buffer, unsigned out_size, BYTE * out_buffer)
{
	if ( (ioctl(this->GetHandle(), HDIO_DRIVE_CMD, buff)) )
		return -1;
	return 0;
}
#endif

int			DevCtl::AtaReadIndentify(int drive, DevCtl::AtaIdentifyDevice & identify)
{
	unsigned char buff[STRANGE_BUFFER_LENGTH];

	memset(buff, 0, STRANGE_BUFFER_LENGTH);
	buff[0] = ATA_IDENTIFY_DEVICE;
	buff[3] = 1;
	if ( (ioctl(this->GetHandle(), HDIO_DRIVE_CMD, buff)) )
		return -1;
	memcpy(&identify, buff+HDIO_DRIVE_CMD_OFFSET, sizeof(identify));

	return 0;
}

int		DevCtl::SmartReadValues(int drive, DevCtl::AtaSmartValues & val)
{
	unsigned char buff[STRANGE_BUFFER_LENGTH];

	memset(buff, 0, STRANGE_BUFFER_LENGTH);
	buff[0] = ATA_SMART_CMD;
	buff[2] = ATA_SMART_READ_VALUES;
	buff[3] = 1;
	if ( (ioctl(this->GetHandle(), HDIO_DRIVE_CMD, buff)) )
		return -1;
	memcpy(&val, buff+HDIO_DRIVE_CMD_OFFSET, sizeof(val));

	return 0;
}

int		DevCtl::SmartReadThresholds(int drive, DevCtl::AtaSmartThresholds & thr)
{
	unsigned char buff[STRANGE_BUFFER_LENGTH];

	memset(buff, 0, STRANGE_BUFFER_LENGTH);
	buff[0] = ATA_SMART_CMD;
	buff[2] = ATA_SMART_READ_THRESHOLDS;
	buff[1] = buff[3] = 1;
	if ( (ioctl(this->GetHandle(), HDIO_DRIVE_CMD, buff)) )
		return -1;
	memcpy(&thr, buff+HDIO_DRIVE_CMD_OFFSET, sizeof(thr));

	return 0;
}

